Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Plugin.cs	(revision 9473)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Problems.BinPacking.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Problems.BinPacking.Views", "3.3.7.9348")]
+  [Plugin("HeuristicLab.Problems.BinPacking.Views", "3.3.7.9440")]
   [PluginFile("HeuristicLab.Problems.BinPacking.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Properties/AssemblyInfo.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Properties/AssemblyInfo.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.Views/3.3/Properties/AssemblyInfo.cs	(revision 9473)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.9348")]
+[assembly: AssemblyFileVersion("3.3.7.9440")]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPotvinDecoder3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPotvinDecoder3D.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointPotvinDecoder3D.cs	(revision 9473)
@@ -0,0 +1,74 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.BinPacking.Dimensions;
+using HeuristicLab.Problems.BinPacking.PackingBin;
+using HeuristicLab.Problems.BinPacking.PackingItem;
+using HeuristicLab.Encodings.PackingEncoding.PackingPlan;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Common;
+using HeuristicLab.Data;
+using HeuristicLab.Collections;
+using HeuristicLab.Encodings.PackingEncoding.Potvin;
+using HeuristicLab.Problems.BinPacking.Interfaces;
+
+namespace HeuristicLab.Problems.BinPacking.Decoders {
+  [Item("Identical bin, three dimensional, extreme points based decoder for the Potvin encoding.", "<Description missing...>")]
+  [StorableClass]
+  public class ExtremePointPotvinDecoder3D : IdenticalBinPackingSolutionDecoder<
+      ThreeDimensionalPacking,
+      CuboidPackingBin,
+      CuboidPackingItem,
+      PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>> {
+
+    public ExtremePointPotvinDecoder3D ()
+      : base() {
+    }
+    [StorableConstructor]
+    protected ExtremePointPotvinDecoder3D (bool deserializing) : base(deserializing) { }
+    protected ExtremePointPotvinDecoder3D(ExtremePointPotvinDecoder3D original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExtremePointPotvinDecoder3D(this, cloner);
+    }
+
+
+    protected override PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> CreatePackingPlanFromEncoding(IPackingSolutionEncoding encodedSolution) {
+
+      var solution = encodedSolution as PotvinEncoding;
+      if (solution == null) throw new InvalidOperationException("Encoding is not of type Potvin-encoding.");
+
+      PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> result = 
+        new PackingPlan<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>(PackingBinMeasuresParameter.ActualValue, PackingItemMeasuresParameter.ActualValue);
+
+      result.PackingItemPositions = ExtremePointsFunctions3D.ExtremePointBasedPacking(ref solution, PackingItemMeasuresParameter.ActualValue, PackingBinMeasuresParameter.ActualValue);
+
+      return result;
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Decoders/3D/EP/ExtremePointsFunctions3D.cs	(revision 9473)
@@ -5,7 +5,9 @@
 using HeuristicLab.Collections;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
 using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
 using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
+using HeuristicLab.Encodings.PackingEncoding.Potvin;
 using HeuristicLab.Problems.BinPacking.Dimensions;
 using HeuristicLab.Problems.BinPacking.Interfaces;
@@ -18,4 +20,145 @@
 
 
+
+    public static ObservableDictionary<int, ThreeDimensionalPacking> ExtremePointBasedPacking(ref PotvinEncoding solution, 
+      ItemList<CuboidPackingItem> itemMeasures, CuboidPackingBin binMeasures) {
+        if (!solution.DelimiterInitialized) {
+          #region Preperations
+          var itemPositions = new ObservableDictionary<int, ThreeDimensionalPacking>();
+          int nrOfBins = 1;
+
+          var occupiedPoints = new List<int[, ,]>();
+          occupiedPoints = IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
+
+          HashSet<ThreeDimensionalPacking> extremePoints = new HashSet<ThreeDimensionalPacking>();
+          extremePoints.Add(new ThreeDimensionalPacking(0, 0, 0, 0, false));
+          #endregion
+
+          Dictionary<int, List<int>> itemIndexesForBin = new Dictionary<int, List<int>>();
+          itemIndexesForBin[0] = new List<int>();
+
+          foreach (int itemIndex in solution.IntVector) {
+            var item = itemMeasures[itemIndex];
+            extremePoints = OrderExtremePoints(extremePoints, occupiedPoints, binMeasures);
+            var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions);
+            if (positionFound != null) {
+              extremePoints.Remove(positionFound);
+            } else {
+              positionFound = new ThreeDimensionalPacking(nrOfBins, 0, 0, 0);
+              occupiedPoints = IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
+              itemIndexesForBin[nrOfBins] = new List<int>();
+              nrOfBins++;
+            }
+            itemPositions[itemIndex] = positionFound;
+            itemIndexesForBin[positionFound.AssignedBin].Add(itemIndex);
+            occupiedPoints = OccupyPointsForNewItem(occupiedPoints, item, positionFound, itemIndex);
+            extremePoints = GenerateNewExtremePointsForNewItem(extremePoints, occupiedPoints, item, positionFound, binMeasures);
+          }
+          List<int> intVector = new List<int>();
+          foreach (var indexes in itemIndexesForBin) {
+            foreach (var index in indexes.Value) {
+              intVector.Add(index);
+            }
+            intVector.Add(-1);
+          }
+          intVector.RemoveAt(intVector.Count - 1);
+          solution.IntVector = new IntegerVector (intVector.ToArray());
+
+          return itemPositions;
+        } else {
+          #region Preperations
+          int nrOfBins = solution.IntVector.Count(i => i.Equals (-1)) + 1;
+
+          //Get all indexes of items for every bin according to int vector
+          Dictionary<int, List<int>> unpackedItemIndexesPerBin = new Dictionary<int, List<int>>();
+          Dictionary<int, HashSet<ThreeDimensionalPacking>> extremePointsForBin = new Dictionary<int, HashSet<ThreeDimensionalPacking>>();
+          var occupiedPoints = new List<int[, ,]>();
+
+          int binCounter = 0;
+          unpackedItemIndexesPerBin[binCounter] = new List<int>();
+          for (int i = 0; i < solution.IntVector.Length; i++) {
+            if (solution.IntVector[i].Equals(-1)) {
+              unpackedItemIndexesPerBin[binCounter++] = new List<int>();
+              extremePointsForBin[i] = new HashSet<ThreeDimensionalPacking>();
+              extremePointsForBin[i].Add(new ThreeDimensionalPacking(i, 0, 0, 0, false));
+              occupiedPoints = IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
+            } else {
+              unpackedItemIndexesPerBin[binCounter].Add(solution.IntVector[i]);
+            }
+
+          }
+
+
+          ObservableDictionary<int, ThreeDimensionalPacking> itemPositions = new ObservableDictionary<int, ThreeDimensionalPacking>();
+          var remainingItems = new List<int>();
+
+          #endregion Preperations
+
+
+
+          //Iterate over all bin-lists
+          for (int binNr = 0; binNr < nrOfBins; binNr++) {
+            //Iterate over the current bin-item-list and find feasible positions in the current bin for each item
+            var unpackedItems = unpackedItemIndexesPerBin[binNr];
+            for (int i = 0; i < unpackedItems.Count; i++) {
+              var itemIndex = unpackedItems[i];
+              var item = itemMeasures[itemIndex];
+
+              extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
+              var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
+              if (positionFound != null) {
+                extremePointsForBin[binNr].Remove(positionFound);
+                itemPositions[itemIndex] = positionFound;
+                occupiedPoints = OccupyPointsForNewItem(occupiedPoints, item, positionFound, itemIndex);
+                extremePointsForBin[binNr] = GenerateNewExtremePointsForNewItem(extremePointsForBin[binNr], occupiedPoints, item, positionFound, binMeasures);
+              } else
+                remainingItems.Add(itemIndex);
+            }
+          }
+
+
+
+          //Packing of remaining items    
+          //Iterate over all bin-lists
+          for (int binNr = 0; binNr < nrOfBins && remainingItems.Count > 0; binNr++) {
+            var unpackedItems = new List<int>(remainingItems);
+            //Iterate over all the remaining items
+            for (int i = 0; i < unpackedItems.Count; i++) {
+              var itemIndex = unpackedItems[i];
+              var item = itemMeasures[itemIndex];
+
+              extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
+              var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
+              if (positionFound != null) {
+                extremePointsForBin[binNr].Remove(positionFound);
+                InsertItemgeneAfterLastItemgeneOfUsedBin(ref solution, itemIndex, binNr);
+                itemPositions[itemIndex] = positionFound;
+                occupiedPoints = OccupyPointsForNewItem(occupiedPoints, item, positionFound, itemIndex);
+                extremePointsForBin[binNr] = GenerateNewExtremePointsForNewItem(extremePointsForBin[binNr], occupiedPoints, item, positionFound, binMeasures);
+                remainingItems.Remove(itemIndex);
+              }
+            }
+            if (remainingItems.Count > 0 && binNr + 1 >= nrOfBins) {
+              extremePointsForBin[nrOfBins] = new HashSet<ThreeDimensionalPacking>();
+              extremePointsForBin[nrOfBins].Add(new ThreeDimensionalPacking(nrOfBins, 0, 0, 0, false));
+              occupiedPoints = IncreaseBinCountForOccupiedPoints(occupiedPoints, binMeasures);
+              nrOfBins++;
+            }
+          }
+
+          return itemPositions;
+        }
+    }
+    private static void InsertItemgeneAfterLastItemgeneOfUsedBin(ref PotvinEncoding solution, int itemIndex, int binNr) { 
+      List<int> temp = new List<int> (solution.IntVector);
+      temp.Remove(itemIndex);
+      var delimiterIndexes = temp.Select((value, index) => value == -1).Select((value, index) => index);
+      int insertionIndex = temp.Count; 
+      if (binNr < delimiterIndexes.Count()) {
+        insertionIndex = delimiterIndexes.ElementAt(binNr);
+      }
+      temp.Insert(insertionIndex, itemIndex);
+      solution.IntVector = new IntegerVector (temp.ToArray());
+    }
 
 
@@ -56,5 +199,5 @@
           var item = itemMeasures[itemIndex];
 
-          extremePointsForBin[binNr] = new HashSet<ThreeDimensionalPacking>(extremePointsForBin[binNr].OrderBy(ep => ep.AssignedBin).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+          extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
           var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
           if (positionFound != null) {
@@ -78,5 +221,5 @@
           var item = itemMeasures[itemIndex];
 
-          extremePointsForBin[binNr] = new HashSet<ThreeDimensionalPacking>(extremePointsForBin[binNr].OrderBy(ep => ep.AssignedBin).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+          extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
           var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions, unpackedItems[i].Rotated);
           if (positionFound != null) {
@@ -147,5 +290,5 @@
           var item = itemMeasures[itemIndex];
 
-          extremePointsForBin[binNr] = new HashSet<ThreeDimensionalPacking>(extremePointsForBin[binNr].OrderBy(ep => ep.AssignedBin).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+          extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
           var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
           if (positionFound != null) {
@@ -170,5 +313,5 @@
           var item = itemMeasures[itemIndex];
 
-          extremePointsForBin[binNr] = new HashSet<ThreeDimensionalPacking>(extremePointsForBin[binNr].OrderBy(ep => ep.AssignedBin).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+          extremePointsForBin[binNr] = OrderExtremePoints(extremePointsForBin[binNr], occupiedPoints, binMeasures);
           var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePointsForBin[binNr], occupiedPoints, itemPositions);
           if (positionFound != null) {
@@ -208,5 +351,5 @@
       foreach (int itemIndex in solution.PackingSequence) {
         var item = itemMeasures[itemIndex];
-        extremePoints = new HashSet<ThreeDimensionalPacking>(extremePoints.OrderBy(ep => ep.AssignedBin).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+        extremePoints = OrderExtremePoints(extremePoints, occupiedPoints, binMeasures);
         var positionFound = FindExtremePointForItem(itemIndex, itemMeasures, binMeasures, extremePoints, occupiedPoints, itemPositions);
         if (positionFound != null) {
@@ -373,4 +516,9 @@
       return extremePoints;
     }
+
+
+    private static HashSet<ThreeDimensionalPacking> OrderExtremePoints(HashSet<ThreeDimensionalPacking> hashSet, List<int[, ,]> occupiedPoints, CuboidPackingBin binMeasures) {
+      return new HashSet<ThreeDimensionalPacking>(hashSet.OrderBy(ep => ep.AssignedBin).ThenBy(ep => ep.Z).ThenBy(ep => ep.X).ThenBy(ep => ep.Y).ThenBy(ep => ShortestPossibleSideFromEP(ep, occupiedPoints, binMeasures)));
+    }
     private static int ShortestPossibleSideFromEP(ThreeDimensionalPacking ep, List<int[, ,]> occupiedPoints, CuboidPackingBin binMeasures) {
       int shortestSide = int.MaxValue;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/ChangePositionMoveAttribute.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/ChangePositionMoveAttribute.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/ChangePositionMoveAttribute.cs	(revision 9473)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("ChangePositionMoveAttribute", "Specifies the tabu attributes for a change position move on an multi component vector.")]
+  [StorableClass]
+  public class ChangePositionMoveAttribute : MultiComponentVectorMoveAttribute {
+    [Storable]
+    public int Index { get; protected set; }
+    [Storable]
+    public int TargetIndex { get; protected set; }
+    [Storable]
+    public int ItemIndex { get; protected set; }
+
+    [StorableConstructor]
+    protected ChangePositionMoveAttribute(bool deserializing) : base(deserializing) { }
+    protected ChangePositionMoveAttribute(ChangePositionMoveAttribute original, Cloner cloner)
+      : base(original, cloner) {
+        this.Index = original.Index;
+        this.TargetIndex = original.TargetIndex;      
+      this.ItemIndex = original.ItemIndex;
+    }
+    public ChangePositionMoveAttribute() : this(-1, -1, -1, -1) { }
+    public ChangePositionMoveAttribute(int index, int targetIndex, int itemIndex, double moveQuality)
+      : base(moveQuality) {
+        Index = index;
+        TargetIndex = targetIndex;
+        ItemIndex = itemIndex;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ChangePositionMoveAttribute(this, cloner);
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/MCVTripleMoveAttribute.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/MCVTripleMoveAttribute.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/MCVTripleMoveAttribute.cs	(revision 9473)
@@ -0,0 +1,73 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("MCVTripleMoveAttribute", "Specifies the tabu attributes for a change position move on an multi component vector.")]
+  [StorableClass]
+  public class MCVTripleMoveAttribute : MultiComponentVectorMoveAttribute {
+    [Storable]
+    public int Index { get; protected set; } 
+    [Storable]
+    public int ItemIndex { get; protected set; }  
+    [Storable]
+    public int TargetIndex { get; protected set; }
+    [Storable]
+    public bool RotationBefore { get; protected set; }
+    [Storable]
+    public bool RotationAfter { get; protected set; }
+    [Storable]
+    public int GroupBefore { get; protected set; }
+    [Storable]
+    public int GroupAfter { get; protected set; }
+
+    [StorableConstructor]
+    protected MCVTripleMoveAttribute(bool deserializing) : base(deserializing) { }
+    protected MCVTripleMoveAttribute(MCVTripleMoveAttribute original, Cloner cloner)
+      : base(original, cloner) {
+        this.Index = original.Index;
+        this.TargetIndex = original.TargetIndex;      
+      this.ItemIndex = original.ItemIndex;
+      this.RotationAfter = original.RotationAfter;
+      this.RotationBefore = original.RotationBefore;
+      this.GroupBefore = original.GroupBefore;
+      this.GroupAfter = original.GroupAfter;
+    }
+    public MCVTripleMoveAttribute() : this(-1, -1, -1, false, false, -1, -1, -1) { }
+    public MCVTripleMoveAttribute(int index, int targetIndex, int itemIndex, bool rotationBefore, bool rotationAfter, int groupBefore, int groupAfter, double moveQuality)
+      : base(moveQuality) {
+        Index = index;
+        TargetIndex = targetIndex;
+        ItemIndex = itemIndex;
+        RotationBefore = rotationBefore;
+        RotationAfter = rotationAfter;
+        GroupBefore = groupBefore;
+        GroupAfter = groupAfter;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MCVTripleMoveAttribute(this, cloner);
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SingleGroupingMoveAttribute.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SingleGroupingMoveAttribute.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SingleGroupingMoveAttribute.cs	(revision 9473)
@@ -29,5 +29,5 @@
   public class SingleGroupingMoveAttribute : MultiComponentVectorMoveAttribute {
     [Storable]
-    public int ItemIndex { get; protected set; }
+    public int Index { get; protected set; }
     [Storable]
     public int AssignedBin { get; protected set; }
@@ -37,11 +37,11 @@
     protected SingleGroupingMoveAttribute(SingleGroupingMoveAttribute original, Cloner cloner)
       : base(original, cloner) {
-      this.ItemIndex = original.ItemIndex;
+      this.Index = original.Index;
       this.AssignedBin = original.AssignedBin;
     }
     public SingleGroupingMoveAttribute() : this(-1, -1, -1) { }
-    public SingleGroupingMoveAttribute(int itemIndex, int assignedBin, double moveQuality)
+    public SingleGroupingMoveAttribute(int index, int assignedBin, double moveQuality)
       : base(moveQuality) {
-      ItemIndex = itemIndex;
+      Index = index;
       AssignedBin = assignedBin;
     }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Attributes/SwapPositionMoveAttribute.cs	(revision 9473)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("SwapPositionMoveAttribute", "Specifies the tabu attributes for a swap sequence move on an multi component vector.")]
+  [StorableClass]
+  public class SwapPositionMoveAttribute : MultiComponentVectorMoveAttribute {
+    [Storable]
+    public int Index1 { get; protected set; }
+    [Storable]
+    public int Index2 { get; protected set; }
+    [Storable]
+    public int ItemIndex1 { get; protected set; }
+    [Storable]
+    public int ItemIndex2 { get; protected set; }
+
+    [StorableConstructor]
+    protected SwapPositionMoveAttribute(bool deserializing) : base(deserializing) { }
+    protected SwapPositionMoveAttribute(SwapPositionMoveAttribute original, Cloner cloner)
+      : base(original, cloner) {
+        this.Index1 = original.Index1;
+        this.Index2 = original.Index2;
+      this.ItemIndex1 = original.ItemIndex1;
+      this.ItemIndex2 = original.ItemIndex2;
+    }
+    public SwapPositionMoveAttribute() : this(-1, -1, -1, -1, -1) { }
+    public SwapPositionMoveAttribute(int index1, int index2, int itemIndex1, int itemIndex2, double moveQuality)
+      : base(moveQuality) {
+        Index1 = index1;
+        Index2 = index2;
+        ItemIndex1 = itemIndex1;
+        ItemIndex2 = itemIndex2;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SwapPositionMoveAttribute(this, cloner);
+    }
+  }
+}
